
(* Copyright 2007 Hewlett Packard under the terms of the MIT X license
   found at http://www.opensource.org/licenses/mit-license.html  *)
   
(* Dyne is an experimental enhancement to Emily that supports promise 
   pipelining among processes on a single computer, enabling effective
   use of multicore and multiprocessor systems in a robust reliable
   deadlock-free fashion *)

    
exception BadType of string
exception BadDyne of string

val stringOf : Far.sendable -> string

val error : Far.sendable -> string -> Far.sendable
val raiseType : Far.sendable -> string -> unit
val raiseDyne : Far.sendable -> string -> unit

val dyne_of_bool : bool -> Far.sendable 
    
val (+:) : Far.sendable -> Far.sendable -> Far.sendable
val (-:) : Far.sendable -> Far.sendable -> Far.sendable
val ( *:) : Far.sendable -> Far.sendable -> Far.sendable
val (/:) : Far.sendable -> Far.sendable -> Far.sendable
val (<:) : Far.sendable -> Far.sendable -> Far.sendable
val (>:) : Far.sendable -> Far.sendable -> Far.sendable
val (<=:) : Far.sendable -> Far.sendable -> Far.sendable
val (>=:) : Far.sendable -> Far.sendable -> Far.sendable
val (^:) : Far.sendable -> Far.sendable -> Far.sendable

val escInt : Far.sendable -> int
val escStr : Far.sendable -> string
val escBool : Far.sendable -> bool
val escList : Far.sendable -> Far.sendable list
val escApp : Far.sendable -> Far.appliable

val apply : Far.sendable -> Far.sendable -> Far.sendable
val ( ->:) : Far.sendable -> Far.sendable -> Far.sendable
val sendA  : Far.sendable -> Far.sendable -> Far.vowS
val sendM : Far.sendable -> string ->Far.sendable -> Far.vowS
val callM : Far.sendable -> string -> Far.sendable -> Far.sendable

val makeObj : (string * Far.func) list -> Far.sendable
