
(* Copyright 2007 Hewlett Packard under the terms of the MIT X license
   found at http://www.opensource.org/licenses/mit-license.html  *)
   
(* Dyne is an experimental enhancement to Emily that supports promise 
   pipelining among processes on a single computer, enabling effective
   use of multicore and multiprocessor systems in a robust reliable
   deadlock-free fashion *)
   

type proxy
 
type appliable = Local of func | Proxy of proxy 
    | ApplyVow of appliable Vow.vow
(* is Err needed since we can use a broken Vow?
   should rename Vow->Vow, Func -> local, Func -> Local, List -> List, 
   Bool -> True|False
*)
(* still need to implement Float, Array, Rational *)
and sendable = Int of int | Str of string | Unit | Err of string 
    | True | False | List of sendable list | Appliable of appliable 
    | Vow of vowS
and func = sendable -> sendable
and vowS = sendable Vow.vow

val send: appliable -> sendable -> vowS

(* need sendOnly: appliable -> sendable -> unit *)

(* need
    val proxy_of_func: func -> proxy
    ??? func_of_proxy: proxy -> func, throw exception if not local? Bad idea *)
(* should we include makeFarResolver: Vow.resolver -> func
    Users can implement this themselves, but is it an important and
    demonstrative convenience? *)

(* below here, all is unsafe, needed by module Vat: remove from safe powerbox mli file *)
type token
type connection = {input : Unix.file_descr; output : Unix.file_descr}

val commWatcher_addConn: connection -> unit
val commWatcher_start: unit -> int
val funcRefsBoss_addFunc: token -> appliable -> unit
val resetChild: unit -> unit
val debugChild: string ref    
val makeToken: string -> token
val makeProxy: token -> connection -> proxy
