
(* Copyright 2007 Hewlett Packard under the terms of the MIT X license
   found at http://www.opensource.org/licenses/mit-license.html  *)
   
(* Dyne is an experimental enhancement to Emily that supports promise 
   pipelining among processes on a single computer, enabling effective
   use of multicore and multiprocessor systems in a robust reliable
   deadlock-free fashion *)
   
type 'a resolution = Broken of exn | Fulfilled of 'a
type 'a status = Pending | Resolved of 'a resolution
type 'a vow
type 'a resolver = 'a resolution -> unit

val make : unit -> ('a vow * 'a resolver)
val wrap: 'a -> 'a vow
 
val (<<-) : ('a -> 'b) -> 'a -> 'b vow
    (*let vow = func <<- arg in ...
    how do you handle multi-args? answer:
    let vow = func arg1 <<- arg2
    *)

val whenDo : 'a vow -> ('a -> 'b) -> 'b vow    
val whenCatch : 'a vow -> ('a resolution -> 'b resolution) -> 'b vow

(* whenCatchOnly cannot be composed of ignore (whenCatch ...) because
   the func must return a resolution, making for 
   very clumsy imperative usage *)
val whenCatchOnly : 'a vow -> ('a resolution -> 'b) -> unit 

val unVow : 'a vow vow -> 'a vow

val nowVal: 'a vow -> 'a resolution option

val all : 'a vow list -> 'a list vow
val both : 'a vow -> 'b vow -> ('a * 'b) vow

